#include <stdio.h>
#include <string.h>
#include <mpi.h>

const int MAX_STRING = 100;

int main() {
  char greeting[MAX_STRING];
  int comm_size; // number of processes
  int my_rank;   // my process rank

  MPI_Init(NULL, NULL); //No MPI calls before this line
  MPI_Comm_size(MPI_COMM_WORLD, &comm_size);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

  if (my_rank != 0) {
    sprintf(greeting, "Greetings from process %d of %d!", my_rank, comm_size);
    // MPI_Send( void* data, int count, MPI_Datatype datatype, int destination, int tag, MPI_Comm communicator)
    MPI_Send(..., strlen(...)+1, ..., 0, 0, ...);
  } else {
    printf("Greetings from process %d of %d!\n", my_rank, comm_size);
    for (int q = 1; q < comm_size; q++) {
      //MPI_Recv( void* data, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm communicator, MPI_Status* status)
      MPI_Recv(..., ..., ..., q, 0, ..., MPI_STATUS_IGNORE);
      ...
    }
  }

  MPI_Finalize(); //No MPI calls after this line
}
